Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/caldyn_gcm.f90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/caldyn_gcm.f90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/caldyn_gcm.f90	(revision 298)
@@ -33,4 +33,5 @@
     USE exner_mod
     USE mpipara
+    USE omp_para, ONLY: omp_master
     IMPLICIT NONE
     CHARACTER(len=255) :: def
@@ -50,5 +51,5 @@
        STOP
     END SELECT
-    IF (is_mpi_root) PRINT *, 'caldyn_conserv=',def
+    IF (is_mpi_root .AND. omp_master) PRINT *, 'caldyn_conserv=',def
 
     CALL allocate_caldyn
@@ -294,5 +295,5 @@
     IF (write_out) THEN
 
-       IF (is_mpi_root) PRINT *,'CALL write_output_fields'
+!       IF (is_mpi_root) PRINT *,'CALL write_output_fields'
 
 ! ---> for openMP test to fix later
@@ -892,4 +893,5 @@
   USE icosa
   USE mpipara
+  USE omp_para, ONLY: omp_master
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -924,5 +926,5 @@
    
     ENDDO
-    IF (is_mpi_root) PRINT*, "mass_tot ", mass_tot,"      dmass_tot ",dmass_tot        
+    IF (is_mpi_root .AND. omp_master) PRINT*, "mass_tot ", mass_tot,"      dmass_tot ",dmass_tot        
 
   END SUBROUTINE check_mass_conservation  
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/check_conserve.f90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/check_conserve.f90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/check_conserve.f90	(revision 298)
@@ -88,5 +88,5 @@
        WRITE(134,*)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang 
        WRITE(134,*)"=================================================="
-       WRITE(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
+!       WRITE(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
        
 4000   FORMAT(10x,'masse',5x,'rmsdpdt',5x,'energie',5x,'enstrophie'  &
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/dissip_gcm.f90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/dissip_gcm.f90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/dissip_gcm.f90	(revision 298)
@@ -68,4 +68,5 @@
   USE mpi_mod
   USE mpipara
+  USE omp_para, ONLY: omp_master
   USE transfert_mod
   USE time_mod
@@ -100,15 +101,15 @@
    CASE('none')
       rayleigh_friction_type=0
-      IF (is_mpi_root) PRINT *, 'No Rayleigh friction'
+      IF (is_mpi_root .AND. omp_master) PRINT *, 'No Rayleigh friction'
    CASE('dcmip2_schaer_noshear')
       rayleigh_friction_type=1
       rayleigh_shear=0
-      IF (is_mpi_root) PRINT *, 'Rayleigh friction : Schaer-like mountain without shear DCMIP2.1'
+      IF (is_mpi_root .AND. omp_master) PRINT *, 'Rayleigh friction : Schaer-like mountain without shear DCMIP2.1'
    CASE('dcmip2_schaer_shear')
       rayleigh_shear=1
       rayleigh_friction_type=2
-      IF (is_mpi_root) PRINT *, 'Rayleigh friction : Schaer-like mountain with shear DCMIP2.2'
+      IF (is_mpi_root .AND. omp_master) PRINT *, 'Rayleigh friction : Schaer-like mountain with shear DCMIP2.2'
    CASE DEFAULT
-      IF (is_mpi_root) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), ' in dissip_gcm.f90/init_dissip'
+      IF (is_mpi_root .AND. omp_master) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), ' in dissip_gcm.f90/init_dissip'
       STOP
    END SELECT
@@ -119,5 +120,5 @@
       rayleigh_tau = rayleigh_tau / scale_factor
       IF(rayleigh_tau<=0) THEN
-         IF (is_mpi_root) PRINT *, 'Forbidden : negative value for rayleigh_friction_tau =',rayleigh_tau
+         IF (is_mpi_root .AND. omp_master) PRINT *, 'Forbidden : negative value for rayleigh_friction_tau =',rayleigh_tau
          STOP
       END IF
@@ -232,15 +233,15 @@
         u=du/dumax
       ENDDO
-      IF (is_mpi_root) PRINT *,"gradiv : it :",it ,": dumax",dumax
+      IF (is_mpi_root .AND. omp_master) PRINT *,"gradiv : it :",it ,": dumax",dumax
 
     ENDDO 
-    IF (is_mpi_root) PRINT *,"gradiv : dumax",dumax
-    IF (is_mpi_root) PRINT *, 'mean T-cell edge size (km)', 1.45*radius/iim_glo/1000., &
+    IF (is_mpi_root .AND. omp_master) PRINT *,"gradiv : dumax",dumax
+    IF (is_mpi_root .AND. omp_master) PRINT *, 'mean T-cell edge size (km)', 1.45*radius/iim_glo/1000., &
                               'effective T-cell half-edge size (km)', dumax**(-.5/nitergdiv)/1000
-    IF (is_mpi_root)  PRINT *, 'Max. time step assuming c=340 m/s and Courant number=2.8 :', &
+    IF (is_mpi_root .AND. omp_master)  PRINT *, 'Max. time step assuming c=340 m/s and Courant number=2.8 :', &
                                2.8/340.*dumax**(-.5/nitergdiv)
 
     cgraddiv=dumax**(-1./nitergdiv)
-    IF (is_mpi_root) PRINT *,"cgraddiv : ",cgraddiv
+    IF (is_mpi_root .AND. omp_master) PRINT *,"cgraddiv : ",cgraddiv
 
     DO ind=1,ndomain
@@ -320,11 +321,11 @@
       ENDDO
       
-      IF (is_mpi_root) PRINT *,"gradrot : it :",it ,": dumax",dumax
+      IF (is_mpi_root .AND. omp_master) PRINT *,"gradrot : it :",it ,": dumax",dumax
 
     ENDDO 
-    IF (is_mpi_root) PRINT *,"gradrot : dumax",dumax
+    IF (is_mpi_root .AND. omp_master) PRINT *,"gradrot : dumax",dumax
   
     cgradrot=dumax**(-1./nitergrot) 
-    IF (is_mpi_root) PRINT *,"cgradrot : ",cgradrot
+    IF (is_mpi_root .AND. omp_master) PRINT *,"cgradrot : ",cgradrot
    
 
@@ -389,5 +390,5 @@
       ENDIF  
       
-      IF (is_mpi_root) PRINT *,"divgrad : it :",it ,": dthetamax",dthetamax
+      IF (is_mpi_root .AND. omp_master) PRINT *,"divgrad : it :",it ,": dthetamax",dthetamax
 
       DO ind=1,ndomain
@@ -401,8 +402,8 @@
     ENDDO 
 
-    IF (is_mpi_root) PRINT *,"divgrad : divgrad",dthetamax
+    IF (is_mpi_root .AND. omp_master) PRINT *,"divgrad : divgrad",dthetamax
   
     cdivgrad=dthetamax**(-1./niterdivgrad) 
-    IF (is_mpi_root) PRINT *,"cdivgrad : ",cdivgrad
+    IF (is_mpi_root .AND. omp_master) PRINT *,"cdivgrad : ",cdivgrad
 
      
@@ -431,9 +432,9 @@
        dtdissip=itau_dissip*dt
     ELSE
-       IF (is_mpi_root) PRINT *,"No dissipation time set, setting itau_dissip to 1000000000"
+       IF (is_mpi_root .AND. omp_master) PRINT *,"No dissipation time set, setting itau_dissip to 1000000000"
        itau_dissip=100000000
     END IF
     itau_dissip=MAX(1,itau_dissip)
-    IF (is_mpi_root) PRINT *,"mintau ",mintau,"itau_dissip",itau_dissip," dtdissip ",dtdissip
+    IF (is_mpi_root .AND. omp_master) PRINT *,"mintau ",mintau,"itau_dissip",itau_dissip," dtdissip ",dtdissip
 
   END SUBROUTINE init_dissip 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/sponge.f90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/sponge.f90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/sponge.f90	(revision 298)
@@ -29,16 +29,16 @@
     tau_sponge = 1.e-4
     CALL getin("tau_sponge",tau_sponge)
-    PRINT*,'tau_sponge = ',tau_sponge
+    IF (is_mpi_master .AND. omp_master) PRINT*,'tau_sponge = ',tau_sponge
 
     iflag_sponge = 0
     CALL getin("iflag_sponge",iflag_sponge)
-    PRINT*,'iflag_sponge = ',iflag_sponge
+    IF (is_mpi_master .AND. omp_master) PRINT*,'iflag_sponge = ',iflag_sponge
     
     mode_sponge = 1
     CALL getin("mode_sponge",mode_sponge)
-    PRINT*,'mode_sponge = ',mode_sponge
+    IF (is_mpi_master .AND. omp_master) PRINT*,'mode_sponge = ',mode_sponge
 
     IF (iflag_sponge == 0) THEN
-      PRINT*,'init_sponge: no sponge'
+      IF (is_mpi_master .AND. omp_master) PRINT*,'init_sponge: no sponge'
       RETURN
     ENDIF
Index: codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/time.f90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/time.f90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/ICOSAGCM/src/time.f90	(revision 298)
@@ -51,4 +51,5 @@
   USE getin_mod
   USE mpipara
+  USE omp_para, ONLY: omp_master
   IMPLICIT NONE
   REAL(rstd) :: run_length
@@ -74,5 +75,5 @@
     write_period=write_period/scale_factor
     itau_out=FLOOR(.5+write_period/dt)
-    IF (is_mpi_root) PRINT *, 'Output frequency (scaled) set to ',write_period, ' : itau_out = ',itau_out
+    IF (is_mpi_root .AND. omp_master) PRINT *, 'Output frequency (scaled) set to ',write_period, ' : itau_out = ',itau_out
     ENDIF 
 
@@ -86,5 +87,5 @@
     CALL getin('itau_physics',itau_physics)
 
-    IF (is_mpi_root)  THEN
+    IF (is_mpi_root .AND. omp_master)  THEN
        PRINT *, 'itaumax=',itaumax
        PRINT *, 'itau_adv=',itau_adv, 'itau_dissip=',itau_dissip, 'itau_physics=',itau_physics
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/disvert_noterre.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/disvert_noterre.F	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/disvert_noterre.F	(revision 298)
@@ -12,4 +12,5 @@
       use ioipsl_getincom
 #endif
+      use mod_phys_lmdz_para, only : is_master
 
       IMPLICIT NONE
@@ -59,5 +60,5 @@
       hybrid=.true. ! default value for hybrid (ie: use hybrid coordinates)
       CALL getin('hybrid',hybrid)
-      write(lunout,*) trim(modname),': hybrid=',hybrid
+      if (is_master) write(lunout,*) trim(modname),': hybrid=',hybrid
 
 ! Ouverture possible de fichiers typiquement E.T.
@@ -82,7 +83,7 @@
 c        <-> energie cinetique, d'apres la note de Frederic Hourdin...
 
-         write(lunout,*)'*****************************'
-         write(lunout,*)'WARNING reading esasig.def'
-         write(lunout,*)'*****************************'
+         if (is_master) write(lunout,*)'*****************************'
+         if (is_master) write(lunout,*)'WARNING reading esasig.def'
+         if (is_master) write(lunout,*)'*****************************'
          READ(99,*) scaleheight
          READ(99,*) dz0
@@ -131,7 +132,7 @@
 
       ELSE IF(ierr4.eq.0) then
-         write(lunout,*)'****************************'
-         write(lunout,*)'Reading z2sig.def'
-         write(lunout,*)'****************************'
+         if (is_master) write(lunout,*)'****************************'
+         if (is_master) write(lunout,*)'Reading z2sig.def'
+         if (is_master) write(lunout,*)'****************************'
 
          READ(99,*) scaleheight
@@ -174,7 +175,8 @@
 
       if (hybrid) then  ! use hybrid coordinates
-         write(lunout,*) "*********************************"
-         write(lunout,*) "Using hybrid vertical coordinates"
-         write(lunout,*) 
+         if (is_master) write(lunout,*) "***************************"
+         if (is_master) write(lunout,*) "Using hybrid vertical",
+     &		" coordinates"
+         if (is_master) write(lunout,*) 
 c        Coordonnees hybrides avec mod
          DO l = 1, llm
@@ -187,7 +189,8 @@
          ap(llmp1) = 0.
       else ! use sigma coordinates
-         write(lunout,*) "********************************"
-         write(lunout,*) "Using sigma vertical coordinates"
-         write(lunout,*) 
+         if (is_master) write(lunout,*) "***************************"
+         if (is_master) write(lunout,*) "Using sigma vertical",
+     &		" coordinates"
+         if (is_master) write(lunout,*) 
 c        Pour ne pas passer en coordonnees hybrides
          DO l = 1, llm
@@ -200,8 +203,8 @@
       bp(llmp1) =   0.
 
-      write(lunout,*) trim(modname),': BP '
-      write(lunout,*)  bp
-      write(lunout,*) trim(modname),': AP '
-      write(lunout,*)  ap
+      if (is_master) write(lunout,*) trim(modname),': BP '
+      if (is_master) write(lunout,*)  bp
+      if (is_master) write(lunout,*) trim(modname),': AP '
+      if (is_master) write(lunout,*)  ap
 
 c     Calcul au milieu des couches :
@@ -226,8 +229,8 @@
       end if
 
-      write(lunout,*) trim(modname),': BPs '
-      write(lunout,*)  bps
-      write(lunout,*) trim(modname),': APs'
-      write(lunout,*)  aps
+      if (is_master) write(lunout,*) trim(modname),': BPs '
+      if (is_master) write(lunout,*)  bps
+      if (is_master) write(lunout,*) trim(modname),': APs'
+      if (is_master) write(lunout,*)  aps
 
       DO l = 1, llm
@@ -236,9 +239,9 @@
       ENDDO
 
-      write(lunout,*)trim(modname),' : PRESNIVS' 
-      write(lunout,*)presnivs 
-      write(lunout,*)'Pseudo altitude of Presnivs : (for a scale ',
-     &                'height of ',scaleheight,' km)' 
-      write(lunout,*)pseudoalt
+      if (is_master) write(lunout,*)trim(modname),' : PRESNIVS' 
+      if (is_master) write(lunout,*)presnivs 
+      if (is_master) write(lunout,*)'Pseudo altitude of Presnivs : ',
+     &		'(for a scale height of ',scaleheight,' km)' 
+      if (is_master) write(lunout,*)pseudoalt
 
 c     --------------------------------------------------
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/inigeom.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/inigeom.F	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/inigeom.F	(revision 298)
@@ -16,4 +16,5 @@
 c
 c
+      use mod_phys_lmdz_para, only : is_master
       IMPLICIT NONE
 c
@@ -160,5 +161,5 @@
 c
 c
-      WRITE(6,3) 
+      if (is_master) WRITE(6,3) 
  3    FORMAT( // 10x,' ....  INIGEOM  date du 01/06/98   ..... ',
      * //5x,'   Calcul des elongations cu et cv  comme sommes des 4 ' /
@@ -183,10 +184,10 @@
       ENDIF
 
-      WRITE(6,*) ' gamdi_gd ',gamdi_gdiv,gamdi_grot,gamdi_h,coefdis,
-     *  nitergdiv,nitergrot,niterh
+      if (is_master) WRITE(6,*) ' gamdi_gd ',gamdi_gdiv,gamdi_grot,
+     *  gamdi_h,coefdis,nitergdiv,nitergrot,niterh
 c
       pi    = 2.* ASIN(1.)
 c
-      WRITE(6,990) 
+      if (is_master) WRITE(6,990) 
 
 c     ----------------------------------------------------------------
@@ -197,5 +198,6 @@
        IF( ysinus )  THEN
 c
-        WRITE(6,*) ' ***  Inigeom ,  Y = Sinus ( Latitude ) *** '
+        if (is_master) WRITE(6,*) ' ***  Inigeom ,  Y = Sinus ',
+     *		'( Latitude ) *** '
 c
 c   .... utilisation de f(x,y )  avec  y  =  sinus de la latitude  .....
@@ -207,5 +209,6 @@
        ELSE
 c
-        WRITE(6,*) '*** Inigeom ,  Y = Latitude  , der. sinusoid . ***'
+        if (is_master) WRITE(6,*) '*** Inigeom ,  Y = Latitude  ,',
+     *		' der. sinusoid . ***'
 
 c  .... utilisation  de f(x,y) a tangente sinusoidale , y etant la latit. ...
@@ -262,5 +265,6 @@
 c   .....................................................................
 
-      WRITE(6,*)'*** Inigeom , Y = Latitude  , der.tg. hyperbolique ***'
+      if (is_master) WRITE(6,*)'*** Inigeom , Y = Latitude  ,',
+     *		' der.tg. hyperbolique ***'
  
        CALL fxyhyper( clat, grossismy, dzoomy, tauy    , 
@@ -656,4 +660,5 @@
 c-----------------------------------------------------------------------
 c
+       if (is_master) then
        WRITE(6,*) '   ***  Coordonnees de la grille  *** '
        WRITE(6,995)
@@ -661,20 +666,23 @@
        WRITE(6,*) '   LONGITUDES  aux pts.   V  ( degres )  '
        WRITE(6,995)
+       end if
         DO i=1,iip1
          rlonvv(i) = rlonv(i)*180./pi
         ENDDO
-       WRITE(6,400) rlonvv
-c
-       WRITE(6,995)
-       WRITE(6,*) '   LATITUDES   aux pts.   V  ( degres )  '
-       WRITE(6,995)
+       if (is_master) WRITE(6,400) rlonvv
+c
+       if (is_master) WRITE(6,995)
+       if (is_master) WRITE(6,*) '   LATITUDES   aux pts.   V  ',
+     *		'( degres )  '
+       if (is_master) WRITE(6,995)
         DO i=1,jjm
          rlatuu(i)=rlatv(i)*180./pi
         ENDDO
-       WRITE(6,400) (rlatuu(i),i=1,jjm)
+       if (is_master) WRITE(6,400) (rlatuu(i),i=1,jjm)
 c
         DO i=1,iip1
           rlonvv(i)=rlonu(i)*180./pi
         ENDDO
+       if (is_master) then
        WRITE(6,995)
        WRITE(6,*) '   LONGITUDES  aux pts.   U  ( degres )  '
@@ -685,9 +693,11 @@
        WRITE(6,*) '   LATITUDES   aux pts.   U  ( degres )  '
        WRITE(6,995)
+       end if
+       if (is_master) WRITE(6,995)
         DO i=1,jjp1
          rlatuu(i)=rlatu(i)*180./pi
         ENDDO
-       WRITE(6,400) (rlatuu(i),i=1,jjp1)
-       WRITE(6,995)
+       if (is_master) WRITE(6,400) (rlatuu(i),i=1,jjp1)
+       if (is_master) WRITE(6,995)
 c
 444    format(f10.3,f6.0)
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/conf_gcm.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/conf_gcm.F	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/conf_gcm.F	(revision 298)
@@ -19,4 +19,5 @@
       use assert_m, only: assert
       use sponge_mod_p, only: callsponge,mode_sponge,nsponge,tetasponge
+      use mod_phys_lmdz_para, only : is_master
       IMPLICIT NONE
 !-----------------------------------------------------------------------
@@ -952,4 +953,5 @@
 
 
+      if (is_master) then
       write(lunout,*)' #########################################'
       write(lunout,*)' Configuration des parametres lus via run.def '
@@ -1007,4 +1009,5 @@
        write(lunout,*)' moyzon_ch = ', moyzon_ch
       endif
+      end if !of if (is_master)
 
       RETURN
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/dynredem_p.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/dynredem_p.F	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/dynredem_p.F	(revision 298)
@@ -11,4 +11,5 @@
       use netcdf95, only: NF95_PUT_VAR
       use control_mod, only : planet_type
+      use mod_phys_lmdz_para, only : is_master
 
       IMPLICIT NONE
@@ -81,9 +82,11 @@
       !!!     .... while keeping everything OK for LMDZ EARTH
       if ((planet_type.eq."generic").or.(planet_type.eq."mars")) then
-          write(lunout,*) trim(modname),' : Planeto-like start file'
+          if (is_master) write(lunout,*) trim(modname),
+     &		' : Planeto-like start file'
           start_file_type="planeto"
           idecal = 4
       else
-          write(lunout,*) trim(modname),' : Earth-like start file'
+          if (is_master) write(lunout,*) trim(modname),
+     &		' : Earth-like start file'
           idecal = 5
       endif
@@ -573,6 +576,6 @@
       ierr = NF_CLOSE(nid) ! fermer le fichier
 
-      PRINT*,'iim,jjm,llm,iday_end',iim,jjm,llm,iday_end
-      PRINT*,'rad,omeg,g,cpp,kappa',
+      if (is_master) PRINT*,'iim,jjm,llm,iday_end',iim,jjm,llm,iday_end
+      if (is_master) PRINT*,'rad,omeg,g,cpp,kappa',
      ,        rad,omeg,g,cpp,kappa
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeropacity.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeropacity.F90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeropacity.F90	(revision 298)
@@ -6,4 +6,5 @@
        USE comgeomfi_h
        USE tracer_h, only: noms,rho_co2,rho_ice
+       use mod_phys_lmdz_para, only : is_master
                   
        implicit none
@@ -86,41 +87,41 @@
       IF (firstcall) THEN
 
-        write(*,*) "Tracers found in aeropacity:"
+        if (is_master) write(*,*) "Tracers found in aeropacity:"
         do iq=1,nq
           tracername=noms(iq)
           if (tracername.eq."co2_ice") then
             i_co2ice=iq
-          write(*,*) "i_co2ice=",i_co2ice
+          if (is_master) write(*,*) "i_co2ice=",i_co2ice
 
           endif
           if (tracername.eq."h2o_ice") then
             i_h2oice=iq
-            write(*,*) "i_h2oice=",i_h2oice
+            if (is_master) write(*,*) "i_h2oice=",i_h2oice
           endif
         enddo
 
         if (noaero) then
-          print*, "No active aerosols found in aeropacity"
+          if (is_master) print*, "No active aerosols found in aeropacity"
         else
-          print*, "If you would like to use aerosols, make sure any old"
-          print*, "start files are updated in newstart using the option"
-          print*, "q=0"
-          write(*,*) "Active aerosols found in aeropacity:"
+          if (is_master) print*, "If you would like to use aerosols, make sure any old"
+          if (is_master) print*, "start files are updated in newstart using the option"
+          if (is_master) print*, "q=0"
+          if (is_master) write(*,*) "Active aerosols found in aeropacity:"
         endif
 
         if ((iaero_co2.ne.0).and.(.not.noaero)) then
-          print*, 'iaero_co2=  ',iaero_co2
+          if (is_master) print*, 'iaero_co2=  ',iaero_co2
         endif
         if (iaero_h2o.ne.0) then
-          print*,'iaero_h2o=  ',iaero_h2o    
+          if (is_master) print*,'iaero_h2o=  ',iaero_h2o    
         endif
         if (iaero_dust.ne.0) then
-          print*,'iaero_dust= ',iaero_dust
+          if (is_master) print*,'iaero_dust= ',iaero_dust
         endif
         if (iaero_h2so4.ne.0) then
-          print*,'iaero_h2so4= ',iaero_h2so4
+          if (is_master) print*,'iaero_h2so4= ',iaero_h2so4
         endif
         if (iaero_back2lay.ne.0) then
-          print*,'iaero_back2lay= ',iaero_back2lay
+          if (is_master) print*,'iaero_back2lay= ',iaero_back2lay
         endif
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_cpp_mugaz.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_cpp_mugaz.F90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_cpp_mugaz.F90	(revision 298)
@@ -18,4 +18,5 @@
 
       use gases_h
+      use mod_phys_lmdz_para, only : is_master
       implicit none
 
@@ -86,11 +87,13 @@
       cpp_c = 1000.0*cpp_c
 
+      if (is_master) then
       print*,'Cp in calc_cpp_mugaz is ',cpp_c,'J kg^-1 K^-1'
       print*,'Mg in calc_cpp_mugaz is ',mugaz_c,'amu'
       print*,'Predefined Cp in physics is ',cpp,'J kg^-1 K^-1'
       print*,'Predefined Mg in physics is ',mugaz,'amu'
+      end if
 
       if (check_cpp_match) then
-         print*,'REQUEST TO CHECK cpp_match :'
+         if (is_master) print*,'REQUEST TO CHECK cpp_match :'
          if((abs(1.-cpp/cpp_c).gt.1.e-6) .or.  &
               (abs(1.-mugaz/mugaz_c).gt.1.e-6)) then
@@ -101,14 +104,14 @@
             stop
          else
-            print*,'--> OK. Settings match composition.'
+            if (is_master) print*,'--> OK. Settings match composition.'
          endif
       endif
 
       if (.not.force_cpp) then
-          print*,'*** Setting cpp & mugaz to computations in calc_cpp_mugaz.'
+          if (is_master) print*,'*** Setting cpp & mugaz to computations in calc_cpp_mugaz.'
           mugaz = mugaz_c
           cpp = cpp_c
       else
-          print*,'*** Setting cpp & mugaz to predefined values.'
+          if (is_master) print*,'*** Setting cpp & mugaz to predefined values.'
       endif
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_rayleigh.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_rayleigh.F90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_rayleigh.F90	(revision 298)
@@ -28,4 +28,5 @@
       use radcommon_h, only: WAVEV, BWNV, DWNV, tstellar, tauray, taurayvar, scalep
       use gases_h
+      use mod_phys_lmdz_para, only : is_master
 
       implicit none
@@ -55,8 +56,8 @@
       do igas=1,ngasmx
          if(igas.eq.vgas)then
-            print*,'variable gas is ',trim(gnom(igas)),' in Rayleigh scattering '
+            if (is_master) print*,'variable gas is ',trim(gnom(igas)),' in Rayleigh scattering '
 	 endif
 	 if((igas/=vgas).and.(gfrac(igas).lt.5.e-2))then
-            print*,'Ignoring ',trim(gnom(igas)),' in Rayleigh scattering '// &
+            if (is_master) print*,'Ignoring ',trim(gnom(igas)),' in Rayleigh scattering '// &
             'as its mixing ratio is less than 0.05.' 
             ! ignore variable gas in Rayleigh calculation
@@ -84,5 +85,5 @@
 
             if((gfrac(igas).eq.1.0).and.(vgas.eq.0))then
-               print*,'Rayleigh scattering is for a pure ',trim(gnom(igas)),' atmosphere.'
+               if (is_master) print*,'Rayleigh scattering is for a pure ',trim(gnom(igas)),' atmosphere.'
                typeknown=.true.
             endif
@@ -92,5 +93,5 @@
 
       if(.not.typeknown)then
-         print*,'Rayleigh scattering is for a mixed gas atmosphere.'
+         if (is_master) print*,'Rayleigh scattering is for a mixed gas atmosphere.'
          typeknown=.true.
       endif
@@ -159,7 +160,7 @@
       IF (L_NSPECTV > 6) THEN
         icantbewrong = L_NSPECTV-6
-        print*,'At 1 atm and lambda = ',WAVEV(icantbewrong),' um'
-        print*,'tau_R = ',TAURAY(icantbewrong)*1013.25
-        print*,'sig_R = ',TAURAY(icantbewrong)*g*mugaz*1.67e-27*100, &
+        if (is_master) print*,'At 1 atm and lambda = ',WAVEV(icantbewrong),' um'
+        if (is_master) print*,'tau_R = ',TAURAY(icantbewrong)*1013.25
+        if (is_master) print*,'sig_R = ',TAURAY(icantbewrong)*g*mugaz*1.67e-27*100, &
                'cm^2 molecule^-1'
       ENDIF
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callcorrk.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callcorrk.F90	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callcorrk.F90	(revision 298)
@@ -18,4 +18,5 @@
       use aerosol_mod, only : iaero_co2,iaero_h2o,iaero_dust,iaero_h2so4, iaero_back2lay
       USE tracer_h
+      USE mod_phys_lmdz_para, only : is_master
 
       implicit none
@@ -218,7 +219,7 @@
 !--------------------------------------------------
 !     set up correlated k
-         print*, "callcorrk: Correlated-k data base folder:",trim(datadir)
+         if (is_master) print*, "callcorrk: Correlated-k data base folder:",trim(datadir)
          call getin_p("corrkdir",corrkdir)
-         print*, "corrkdir = ",corrkdir
+         if (is_master) print*, "corrkdir = ",corrkdir
          write( tmp1, '(i3)' ) L_NSPECTI
          write( tmp2, '(i3)' ) L_NSPECTV
@@ -272,20 +273,20 @@
          if ((iaer.eq.iaero_co2).and.tracer.and.(igcm_co2_ice.gt.0)) then ! treat condensed co2 particles.
 	    call co2_reffrad(ngrid,nlayer,nq,pq,reffrad(1,1,iaero_co2))
-            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
-            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            if (is_master) print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            if (is_master) print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
 	 end if
          if ((iaer.eq.iaero_h2o).and.water) then ! treat condensed water particles. to be generalized for other aerosols
 	    call h2o_reffrad(ngrid,nlayer,pq(1,1,igcm_h2o_ice),pt, &
                              reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
-            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
-            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            if (is_master) print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            if (is_master) print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
          endif
          if(iaer.eq.iaero_dust)then
 	    call dust_reffrad(ngrid,nlayer,reffrad(1,1,iaero_dust))
-            print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
+            if (is_master) print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
          endif
          if(iaer.eq.iaero_h2so4)then
 	    call h2so4_reffrad(ngrid,nlayer,reffrad(1,1,iaero_h2so4))
-            print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
+            if (is_master) print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
          endif
           if(iaer.eq.iaero_back2lay)then
@@ -548,7 +549,7 @@
             muvarrad(2*nlayer+1)=muvar(ig,1)
 
-            print*,'Recalculating qvar with VARIABLE epsi for kastprof'
-            print*,'Assumes that the variable gas is H2O!!!'
-            print*,'Assumes that there is only one tracer'
+            if (is_master) print*,'Recalculating qvar with VARIABLE epsi for kastprof'
+            if (is_master) print*,'Assumes that the variable gas is H2O!!!'
+            if (is_master) print*,'Assumes that there is only one tracer'
             !i_var=igcm_h2o_vap
             i_var=1
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/iniaerosol.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/iniaerosol.F	(revision 297)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/iniaerosol.F	(revision 298)
@@ -4,4 +4,5 @@
       use radinc_h, only: naerkind
       use aerosol_mod
+      use mod_phys_lmdz_para, only : is_master
 
       IMPLICIT NONE
@@ -26,5 +27,5 @@
          iaero_co2=ia
       endif
-      write(*,*) '--- CO2 aerosol = ', iaero_co2
+      if (is_master) write(*,*) '--- CO2 aerosol = ', iaero_co2
  
       if (aeroh2o) then
@@ -32,5 +33,5 @@
          iaero_h2o=ia
       endif
-      write(*,*) '--- H2O aerosol = ', iaero_h2o
+      if (is_master) write(*,*) '--- H2O aerosol = ', iaero_h2o
 
       if (dusttau.gt.0) then
@@ -38,5 +39,5 @@
          iaero_dust=ia
       endif
-      write(*,*) '--- Dust aerosol = ', iaero_dust
+      if (is_master) write(*,*) '--- Dust aerosol = ', iaero_dust
 
       if (aeroh2so4) then
@@ -44,5 +45,5 @@
          iaero_h2so4=ia
       endif
-      write(*,*) '--- H2SO4 aerosol = ', iaero_h2so4
+      if (is_master) write(*,*) '--- H2SO4 aerosol = ', iaero_h2so4
       
       if (aeroback2lay) then
@@ -50,7 +51,8 @@
          iaero_back2lay=ia
       endif
-      write(*,*) '--- Two-layer aerosol = ', iaero_back2lay
+      if (is_master) write(*,*) '--- Two-layer aerosol = ',
+     &		 iaero_back2lay
 
-      write(*,*) '=== Number of aerosols= ', ia
+      if (is_master) write(*,*) '=== Number of aerosols= ', ia
       
 ! For the zero aerosol case, we currently make a dummy co2 aerosol which is zero everywhere.
